unit mainfrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, SDL_Colsel,
  SDL_Thumbnails;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Panel1: TPanel;
    Thumbnails1: TThumbnails;
    SBarFirstSlide: TScrollBar;
    Splitter1: TSplitter;
    Panel2: TPanel;
    CBoxAntiAlias: TCheckBox;
    SBarFocusWidth: TScrollBar;
    SBarSlideDist: TScrollBar;
    SBarSlideSize: TScrollBar;
    CSelFocus: TColSel;
    SBarMargin: TScrollBar;
    CBoxOuterFrame: TComboBox;
    CboxInnerFrame: TComboBox;
    CSelCovercolor: TColSel;
    SBSampleStyle1: TSpeedButton;
    SBSampleStyle2: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    BButExit: TBitBtn;
    Label9: TLabel;
    CSelSelected: TColSel;
    CBoxSlideSelMode: TComboBox;
    Label10: TLabel;
    procedure Thumbnails1ImageRequest(Sender: TObject; ThumbID: Integer;
      var HowToProcess: TImageRequestProcessing; var MarkIt: integer;
      var ImgBuffer: TBitmap);
    procedure SBarFirstSlideScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure Thumbnails1ImageClick(Sender: TObject; X, Y,
      ThumbID: Integer);
    procedure CBoxAntiAliasClick(Sender: TObject);
    procedure SBarFocusWidthChange(Sender: TObject);
    procedure SBarSlideDistChange(Sender: TObject);
    procedure SBarSlideSizeChange(Sender: TObject);
    procedure CSelFocusChange(Sender: TObject);
    procedure SBarMarginChange(Sender: TObject);
    procedure CBoxOuterFrameChange(Sender: TObject);
    procedure CboxInnerFrameChange(Sender: TObject);
    procedure CSelCovercolorChange(Sender: TObject);
    procedure SBSampleStyle1Click(Sender: TObject);
    procedure SBSampleStyle2Click(Sender: TObject);
    procedure BButExitClick(Sender: TObject);
    procedure CSelSelectedChange(Sender: TObject);
    procedure CBoxSlideSelModeChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  SDL_sdlbase, SDL_math1;

(******************************************************************************)
procedure TForm1.Thumbnails1ImageRequest(Sender: TObject; ThumbID: Integer;
  var HowToProcess: TImageRequestProcessing; var MarkIt: integer;
  var ImgBuffer: TBitmap);
(******************************************************************************)

var
  FName : string;

begin
FName := 'img_'+Decimal(ThumbID,3)+'.bmp';
if FileExists (FName)
  then begin
       ImgBuffer.LoadFromFile(FName);
       HowToProcess := irpShowSlide;
       Markit := 9;
       end
  else begin
       HowToProcess := irpShowEMpty;
       end;
end;

(******************************************************************************)
procedure TForm1.SBarFirstSlideScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
(******************************************************************************)

begin
Thumbnails1.FirstThumbIdx := 1+ScrollPos/10;
end;

(******************************************************************************)
procedure TForm1.Thumbnails1ImageClick(Sender: TObject; X, Y,
  ThumbID: Integer);
(******************************************************************************)

begin
Image1.Picture.LoadFromFile('img_'+Decimal(ThumbID,3)+'.bmp');
end;

(******************************************************************************)
procedure TForm1.CBoxAntiAliasClick(Sender: TObject);
(******************************************************************************)

begin
Thumbnails1.AntiAlias := CBoxAntiAlias.Checked;
end;

(******************************************************************************)
procedure TForm1.SBarFocusWidthChange(Sender: TObject);
(******************************************************************************)

begin
Thumbnails1.FocusLinewidth := SBarFocusWidth.Position;
end;

(******************************************************************************)
procedure TForm1.SBarSlideDistChange(Sender: TObject);
(******************************************************************************)

begin
Thumbnails1.SlideDistance := SBarSlideDist.Position;
end;

(******************************************************************************)
procedure TForm1.SBarSlideSizeChange(Sender: TObject);
(******************************************************************************)

begin
Thumbnails1.SlideSize := SBarSlideSize.Position;
end;


(******************************************************************************)
procedure TForm1.CSelFocusChange(Sender: TObject);
(******************************************************************************)

begin
Thumbnails1.ColorFocus := CSelFocus.SelColor;
end;


(******************************************************************************)
procedure TForm1.SBarMarginChange(Sender: TObject);
(******************************************************************************)

begin
Thumbnails1.SlideMargin := SBarMargin.Position;
end;

(******************************************************************************)
procedure TForm1.CBoxOuterFrameChange(Sender: TObject);
(******************************************************************************)

begin
Thumbnails1.OuterFrameStyle := TFrameStyle(CBoxOuterFrame.ItemIndex);
end;


(******************************************************************************)
procedure TForm1.CboxInnerFrameChange(Sender: TObject);
(******************************************************************************)

begin
Thumbnails1.InnerFrameStyle := TFrameStyle(CBoxInnerFrame.ItemIndex);
end;

(******************************************************************************)
procedure TForm1.CSelCovercolorChange(Sender: TObject);
(******************************************************************************)

begin
Thumbnails1.ColorCover := CSelCoverColor.SelColor;
end;

(******************************************************************************)
procedure TForm1.SBSampleStyle1Click(Sender: TObject);
(******************************************************************************)

begin
CSelCoverColor.SelColor := clSilver;
Thumbnails1.ColorCover := CSelCoverColor.SelColor;

CBoxInnerFrame.ItemIndex := ord(fsLowered);
Thumbnails1.InnerFrameStyle := TFrameStyle(CBoxInnerFrame.ItemIndex);

CBoxOuterFrame.ItemIndex := ord(fsRaised);
Thumbnails1.OuterFrameStyle := TFrameStyle(CBoxOuterFrame.ItemIndex);

SBarMargin.Position := 7;
Thumbnails1.SlideMargin := SBarMargin.Position;

CSelFocus.SelColor := clYellow;
Thumbnails1.ColorFocus := CSelFocus.SelColor;

SBarSlideSize.Position := 140;
Thumbnails1.SlideSize := SBarSlideSize.Position;

SBarSlideDist.Position := 4;
Thumbnails1.SlideDistance := SBarSlideDist.Position;

SBarFocusWidth.Position := 5;
Thumbnails1.FocusLinewidth := SBarFocusWidth.Position;
end;

(******************************************************************************)
procedure TForm1.SBSampleStyle2Click(Sender: TObject);
(******************************************************************************)

begin
CSelCoverColor.SelColor := clNavy;
Thumbnails1.ColorCover := CSelCoverColor.SelColor;

CBoxInnerFrame.ItemIndex := ord(fsSimple);
Thumbnails1.InnerFrameStyle := TFrameStyle(CBoxInnerFrame.ItemIndex);

CBoxOuterFrame.ItemIndex := ord(fsNone);
Thumbnails1.OuterFrameStyle := TFrameStyle(CBoxOuterFrame.ItemIndex);

SBarMargin.Position := 7;
Thumbnails1.SlideMargin := SBarMargin.Position;

CSelFocus.SelColor := clWhite;
Thumbnails1.ColorFocus := CSelFocus.selcolor;

SBarSlideSize.Position := 300;
Thumbnails1.SlideSize := SBarSlideSize.Position;

SBarSlideDist.Position := 2;
Thumbnails1.SlideDistance := SBarSlideDist.Position;

SBarFocusWidth.Position := 5;
Thumbnails1.FocusLinewidth := SBarFocusWidth.Position;
end;


(******************************************************************************)
procedure TForm1.BButExitClick(Sender: TObject);
(******************************************************************************)

begin
close;
end;



(******************************************************************************)
procedure TForm1.CSelSelectedChange(Sender: TObject);
(******************************************************************************)

begin
Thumbnails1.ColorSelected := CSelSelected.SelColor;
end;

(******************************************************************************)
procedure TForm1.CBoxSlideSelModeChange(Sender: TObject);
(******************************************************************************)

begin
Thumbnails1.SlideSelectMode := TSlideSelectMode (CBoxSlideSelMode.ItemIndex);
end;

(******************************************************************************)
procedure TForm1.FormShow(Sender: TObject);
(******************************************************************************)

begin
if SDL_thumbnails.IsLightEd
  then CBoxAntiAlias.Enabled := false
  else Thumbnails1.AntiAlias := true;
end;

end.
